| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions
Tp::Client::CallStreamInterfaceMediaInterface Class Reference

`#include <TelepathyQt/CallStream>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply CompleteSendingStateChange (uint state, int timeout=-1)
- QDBusPendingReply ReportSendingFailure (uint reason, const QString &error, const QString &message, int timeout=-1)
- QDBusPendingReply CompleteReceivingStateChange (uint state, int timeout=-1)
- QDBusPendingReply ReportReceivingFailure (uint reason, const QString &error, const QString &message, int timeout=-1)
- QDBusPendingReply SetCredentials (const QString &username, const QString &password, int timeout=-1)
- QDBusPendingReply AddCandidates (const Tp::CandidateList &candidates, int timeout=-1)
- QDBusPendingReply FinishInitialCandidates (int timeout=-1)
- QDBusPendingReply Fail (const Tp::CallStateReason &reason, int timeout=-1)

## Signals

- void SendingStateChanged (uint state)
- void ReceivingStateChanged (uint state)
- void LocalCandidatesAdded (const Tp::CandidateList &candidates)
- void LocalCredentialsChanged (const QString &username, const QString &password)
- void RelayInfoChanged (const Tp::StringVariantMapList &relayInfo)
- void STUNServersChanged (const Tp::SocketAddressIPList &servers)
- void ServerInfoRetrieved ()
- void EndpointsChanged (const Tp::ObjectPathList &endpointsAdded, const Tp::ObjectPathList &endpointsRemoved)
- void ICERestartRequested ()

## Public Member Functions

- CallStreamInterfaceMediaInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- CallStreamInterfaceMediaInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- CallStreamInterfaceMediaInterface (Tp::DBusProxy *proxy)
- CallStreamInterfaceMediaInterface (const Tp::Client::CallStreamInterface &mainInterface)
- CallStreamInterfaceMediaInterface (const Tp::Client::CallStreamInterface &mainInterface, QObject *parent)
- Tp::PendingVariant * requestPropertySendingState () const
- Tp::PendingVariant * requestPropertyReceivingState () const
- Tp::PendingVariant * requestPropertyTransport () const
- Tp::PendingVariant * requestPropertyLocalCandidates () const
- Tp::PendingVariant * requestPropertyLocalCredentials () const
- Tp::PendingVariant * requestPropertySTUNServers () const
- Tp::PendingVariant * requestPropertyRelayInfo () const
- Tp::PendingVariant * requestPropertyHasServerInfo () const
- Tp::PendingVariant * requestPropertyEndpoints () const
- Tp::PendingVariant * requestPropertyICERestartPending () const
- Tp::PendingVariantMap * requestAllProperties () const

## Static Public Member Functions

- static QLatin1String staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Call1.Stream.Interface.Media".

## Constructor & Destructor Documentation

Tp::Client::CallStreamInterfaceMediaInterface::CallStreamInterfaceMediaInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallStreamInterfaceMediaInterface associated with the given object on the session bus.

Parameters:

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallStreamInterfaceMediaInterface::CallStreamInterfaceMediaInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a CallStreamInterfaceMediaInterface associated with the given object on the given bus.

Parameters:

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::CallStreamInterfaceMediaInterface::CallStreamInterfaceMediaInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a CallStreamInterfaceMediaInterface associated with the same object as the given proxy.

Parameters:

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::CallStreamInterfaceMediaInterface::CallStreamInterfaceMediaInterface | ( | const Tp::Client::CallStreamInterface & | mainInterface | ) | `[explicit]`

Creates a CallStreamInterfaceMediaInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters:

  mainInterface | The proxy to use.

Tp::Client::CallStreamInterfaceMediaInterface::CallStreamInterfaceMediaInterface | ( | const Tp::Client::CallStreamInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a CallStreamInterfaceMediaInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters:

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::CallStreamInterfaceMediaInterface::staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Call1.Stream.Interface.Media", which this class represents.

Returns:
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertySendingState | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `SendingState` of type `uint`.

Indicates whether the streaming implementation is/should be sending media for this stream. The streaming implementation should be able to rely on reading this value and listening to SendingStateChanged to determine whether it should be sending media or not. It should not need to listen to the Hold interfaces on the Call/Content. Feedback on success should be given via CompleteSendingStateChange. Failures should be reported via ReportSendingFailure.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyReceivingState | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `ReceivingState` of type `uint`.

The counterpart of SendingState. Indicates whether the streaming implementation is/should be expecting to receive media for this stream. The CM should only tell the streaming implementation to stop receiving if it has been told to put the stream on hold, or the stream has been removed from the call.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyTransport | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `Transport` of type `uint`.

The transport for this stream.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyLocalCandidates | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `LocalCandidates` of type `Tp::CandidateList`.

[FIXME]. Change notification is via the LocalCandidatesAdded signal.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyLocalCredentials | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `LocalCredentials` of type `Tp::StreamCredentials`.

The local credentials are sent to the remote site over the signalling protocol. They are used in ICE to make sure that the connectivity checks come from the right peer. Change notification is via the LocalCredentialsChanged signal. This property will be a pair of empty strings if ICE has not yet been started.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertySTUNServers | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `STUNServers` of type `Tp::SocketAddressIPList`.

The IP addresses of possible STUN servers to use for NAT traversal, as dotted-quad IPv4 address literals or RFC2373 IPv6 address literals. Change notification is via the STUNServersChanged() signal. The IP addresses MUST NOT be given as DNS hostnames.

High-quality connection managers already need an asynchronous DNS resolver, so they might as well resolve this name to an IP to make life easier for streaming implementations.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyRelayInfo | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `RelayInfo` of type `Tp::StringVariantMapList`.

A list of mappings describing TURN or Google relay servers available for the client to use in its candidate gathering, as determined from the protocol. Well-known map keys are:

`ip` - s
  The IP address of the relay server as a dotted-quad IPv4 address literal or an RFC2373 IPv6 address literal. This MUST NOT be a DNS hostname.
  High-quality connection managers already need an asynchronous DNS resolver, so they might as well resolve this name to an IP and make life easier for streaming implementations.
`type` - s

  Either `udp` for UDP (UDP MUST be assumed if this key is omitted), `tcp` for TCP, or `tls`.

  The precise meaning of this key depends on the Transport property: if Transport is ICE, `tls` means TLS over TCP as referenced by ICE draft 19, and if Transport is GTalk_P2P, `tls` means a fake SSL session over TCP as implemented by libjingle.

`port` - q
  The UDP or TCP port of the relay server as an ASCII unsigned integer
`unique-id` - s
  A string identifying the relay server. If two RelayInfo entries have the same unique-id, but different `type`s, there is usually little point in connecting to both. Use `priority` to determine which version to prefer in this case. Can also be used by the streaming implementation to avoid connecting to the same relay multiple times if relaying is required for both audio and video.
`priority` - u
  A number determining which version of a server to prefer (if multiple are present with the same `unique-id`, the one with the highest priority should be used, or the streaming implementation should use the one whose `type` has the most desirable properties)
`username` - s
  The username to use
`password` - s
  The password to use
`component` - u
  The component number to use this relay server for, as an ASCII unsigned integer; if not included, this relay server may be used for any or all components.
  In ICE draft 6, as used by Google Talk, credentials are only valid once, so each component needs relaying separately.

An equivalent of the gtalk-p2p-relay-token property on MediaSignalling channels is not included here. The connection manager should be responsible for making the necessary HTTP requests to turn the token into a username and password.

The type of relay server that this represents depends on the value of the Transport property. If Transport is ICE, this is a TURN server; if Transport is GTalk_P2P, this is a Google relay server; otherwise, the meaning of RelayInfo is undefined.

If relaying is not possible for this stream, the list is empty.

Change notification is given via the RelayInfoChanged() signal.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyHasServerInfo | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `HasServerInfo` of type `bool`.

True if all the initial information about STUN servers and Relay servers has been retrieved. Change notification is via the ServerInfoRetrieved() signal.

Streaming implementations that can't cope with STUN and relay servers being added later SHOULD wait for this property to become true before proceeding.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyEndpoints | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `Endpoints` of type `Tp::ObjectPathList`.

The list of Endpoint objects that exist for this stream. Change notification is via the EndpointsChanged signal.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::CallStreamInterfaceMediaInterface::requestPropertyICERestartPending | ( |  | ) | const`[inline]`

Asynchronous getter for the remote object property `ICERestartPending` of type `bool`.

State recovery for ICERestartRequested. Set when the signal is emitted, and unset when SetCredentials is called. Useful for debugging.

Returns:
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::CallStreamInterfaceMediaInterface::requestAllProperties | ( |  | ) | const`[inline]`

Request all of the DBus properties on the interface.

Returns:
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::CompleteSendingStateChange | ( | uint | state,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `CompleteSendingStateChange` on the remote object.

Called in response to SendingStateChanged() (Pending_*, *) to indicate that the media state has successfully progressed from Pending_{Start, Stop, Pause} to the corresponding non-pending state.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  state | The new (non-pending) value of SendingState.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::ReportSendingFailure | ( | uint | reason,
|  | const QString & | error,
|  | const QString & | message,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `ReportSendingFailure` on the remote object.

Can be called at any point to indicate a failure in the outgoing portion of the stream.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::CompleteReceivingStateChange | ( | uint | state,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `CompleteReceivingStateChange` on the remote object.

Called in response to ReceivingStateChanged() (Pending_*, *) to indicate that the media state has successfully progressed from Pending_{Start, Stop, Pause} to the corresponding non-pending state.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  state | The new (non-pending) value of ReceivingState.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::ReportReceivingFailure | ( | uint | reason,
|  | const QString & | error,
|  | const QString & | message,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `ReportReceivingFailure` on the remote object.

Can be called at any point to indicate a failure in the incoming portion of the stream.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::SetCredentials | ( | const QString & | username,
|  | const QString & | password,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `SetCredentials` on the remote object.

Used to set the username fragment and password for streams that have global credentials.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  username | The username to use when authenticating on the stream.
  password | The password to use when authenticating on the stream.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::AddCandidates | ( | const Tp::CandidateList & | candidates,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `AddCandidates` on the remote object.

Add candidates to the LocalCandidates property and signal them to the remote contact(s). Note that connection managers MAY delay the sending of candidates until FinishInitialCandidates is called.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  candidates | The candidates to be added.
  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::FinishInitialCandidates | ( | int | timeout = `-1` | ) | `[inline, slot]`

Begins a call to the D-Bus method `FinishInitialCandidates` on the remote object.

This indicates to the CM that the initial batch of candidates has been added, and should now be processed/sent to the remote side. Protocols supporting Raw UDP SHOULD wait for FinishInitialCandidates, and then set the lowest priority candidate as the Raw UDP candidate.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  timeout | The timeout in milliseconds.

QDBusPendingReply Tp::Client::CallStreamInterfaceMediaInterface::Fail | ( | const Tp::CallStateReason & | reason,
|  | int | timeout = `-1`
| ) |  | `[inline, slot]`

Begins a call to the D-Bus method `Fail` on the remote object.

Signal an unrecoverable error for this stream, and remove it. If all streams are removed from a content, then it will also be removed.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters:

  reason | A structured reason for stream removal.
  timeout | The timeout in milliseconds.

void Tp::Client::CallStreamInterfaceMediaInterface::SendingStateChanged | ( | uint | state | ) | `[signal]`

Represents the signal `SendingStateChanged` on the remote object.

Change notification for SendingState. Note that this information is duplicated onto the Stream interface, so that UIs can ignore the Media interface, and streaming implementations can ignore everything but the media interface.

Parameters:

  state | The new value of SendingState.

void Tp::Client::CallStreamInterfaceMediaInterface::ReceivingStateChanged | ( | uint | state | ) | `[signal]`

Represents the signal `ReceivingStateChanged` on the remote object.

Change notification for ReceivingState.

Parameters:

  state | The new value of ReceivingState.

void Tp::Client::CallStreamInterfaceMediaInterface::LocalCandidatesAdded | ( | const Tp::CandidateList & | candidates | ) | `[signal]`

Represents the signal `LocalCandidatesAdded` on the remote object.

Emitted when local candidates are added to the LocalCandidates property.

Parameters:

  candidates | Candidates that have been added.

void Tp::Client::CallStreamInterfaceMediaInterface::LocalCredentialsChanged | ( | const QString & | username,
|  | const QString & | password
| ) |  | `[signal]`

Represents the signal `LocalCredentialsChanged` on the remote object.

Emitted when the value of LocalCredentials changes to a non-empty value. This should only happen when the streaming implementation calls SetCredentials, so this signal is mostly useful for debugging.

void Tp::Client::CallStreamInterfaceMediaInterface::RelayInfoChanged | ( | const Tp::StringVariantMapList & | relayInfo | ) | `[signal]`

Represents the signal `RelayInfoChanged` on the remote object.

Emitted when the value of RelayInfo changes.

void Tp::Client::CallStreamInterfaceMediaInterface::STUNServersChanged | ( | const Tp::SocketAddressIPList & | servers | ) | `[signal]`

Represents the signal `STUNServersChanged` on the remote object.

Emitted when the value of STUNServers changes.

void Tp::Client::CallStreamInterfaceMediaInterface::ServerInfoRetrieved | ( |  | ) | `[signal]`

Represents the signal `ServerInfoRetrieved` on the remote object.

Signals that the initial information about STUN and Relay servers has been retrieved, i.e. the HasServerInfo property is now true.

void Tp::Client::CallStreamInterfaceMediaInterface::EndpointsChanged | ( | const Tp::ObjectPathList & | endpointsAdded,
|  | const Tp::ObjectPathList & | endpointsRemoved
| ) |  | `[signal]`

Represents the signal `EndpointsChanged` on the remote object.

Emitted when the Endpoints property changes.

Parameters:

  endpointsAdded | Endpoints that were added.
  endpointsRemoved | Endpoints that no longer exist.

void Tp::Client::CallStreamInterfaceMediaInterface::ICERestartRequested | ( |  | ) | `[signal]`

Represents the signal `ICERestartRequested` on the remote object.

Emitted when the remote side requests an ICE restart (e.g. third party call control, when the remote endpoint changes). The streaming implementation should call SetCredentials again.

void Tp::Client::CallStreamInterfaceMediaInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  | `[protected, virtual]`

Reimplemented from Tp::AbstractInterface.